---
jupytext:
  formats: ipynb,md:myst
  text_representation:
    extension: .md
    format_name: myst
    format_version: 0.13
    jupytext_version: 1.16.1
kernelspec:
  display_name: Python 3 (ipykernel)
  language: python
  name: python3
---

# MethNum/L2 : Examen - 17 decembre 2024

*La durée de l'examen est de 3h, de 14h à 17h*

```{code-cell} ipython3
---
editable: true
slideshow:
  slide_type: ''
tags: [raises-exception]
---
NOM    =  # entrer votre nom
PRENOM =  # entrer votre prénom
GROUPE =  #
```

+++ {"editable": true, "slideshow": {"slide_type": ""}}

## Table des matières:
* [Règles pour la rédaction](#R1)
* [Règles pour la soumission](#R2)
* [Barème indicatif](#B)
* [Exercice 1 : Remplacement d’une fonction coûteuse à calculer (résolution d'équations et interpolation)](#Ex1)
* [Exercice 2 : Stéganographie (traitement d'images)](#Ex2)
* [Exercice 3 : Oscillateur harmonique amorti forcé (equations différentielles)](#Ex3)
* [Exercice 4 : Jeu de cartes (classes, seulement pour les LDD-MP)](#Ex4)

+++ {"editable": true, "slideshow": {"slide_type": ""}}

### Règles pour la rédaction:<a class="anchor" id="R1"></a>

- **Ne changez PAS** le nom de ce fichier, même pour mettre votre nom.
- N'oubliez pas d'indiquer vos nom, prénom et nom de groupe dans la case située en haut de ce document. 
- L'accès à Internet et aux documents du cours est autorisé (notamment ici [https://methnum.pages.in2p3.fr/l2-profs/](https://methnum.pages.in2p3.fr/l2-profs/))
- Toute ouverture d'une fenêtre contenant une messagerie quelconque (Gmail, Discord, etc.) ou d'agent conversationnel (Chatgpt, Copilot, etc.) entrainera l'édition d'un PV de fraude immédiatement.
- Les exercices sont indépendants. N’oubliez pas de mettre un titre à vos graphiques et de nommer les axes.
- L'exercice 4 doit être traité seulement par les étudiants  de la double licence math-physique.
- Vous devez répondre aux questions dans les cellules prédisposées, en remplaçant les lignes :


```python 
#VOTRE REPONSE ICI
``` 
ou 

```python 
#VOTRE CODE ICI
``` 

par vos réponses ou vos codes.
- 15 minutes avant la fin de l'épreuve, redémarrez votre noyau et re-exécutez toutes vos cellules dans l'ordre pour corriger les bugs de variable en mémoire!

### Règles pour la soumission: <a class="anchor" id="R2"></a>

- Une fois le texte de votre examen complété, dans le panneau à gauche de JupyterLite, cliquez avec le bouton droit de votre souris sur le nom du fichier et choisissez l'option "download".
- **Pour soumettre votre texte, poster le fichier .ipynb au lien suivant :**

[https://ecampus.paris-saclay.fr/mod/assign/view.php?id=1905024](https://ecampus.paris-saclay.fr/mod/assign/view.php?id=1905024)

n'oubliez pas de vous connecter avec votre nom d'utilisateur!

- **Si et seulement si vous ne pouvez pas accéder à ecampus avec vos identifiants**, vous devez soumettre votre texte sur un des liens indiqués sur le tableau suivant

| Group | Horaire | Salle | Enseignant | Lien téléchargement |
| -------- | ------- |-------- | ------- |-------- |
| TP_1_1 | mardi matin | 224 | Corinne Donzaud       |[https://box.in2p3.fr/s/GXqrA2ZXtxjDaJp](https://box.in2p3.fr/s/GXqrA2ZXtxjDaJp) | 
| TP_1_2 | mardi matin | 226 | Dana-codruta Marinica | [https://box.in2p3.fr/s/7dRPJxE29Yr26dH](https://box.in2p3.fr/s/7dRPJxE29Yr26dH) |
| TP_2_1 | mercredi après-midi |  224 | Corinne Donzaud | [https://box.in2p3.fr/s/tB5DaiYbdw9er92](https://box.in2p3.fr/s/tB5DaiYbdw9er92) |
| TP_2_2 | mercredi après-midi |  226 | Reda Nabil | [https://box.in2p3.fr/s/Pdo3P6Qi8Sgsxi8](https://box.in2p3.fr/s/Pdo3P6Qi8Sgsxi8) |
| TP_3_1 | mardi après-midi |  224 | Alberto Zobelli | [https://box.in2p3.fr/s/zzPQHStLtcQq5zB](https://box.in2p3.fr/s/zzPQHStLtcQq5zB) | 
| TP_3_2 | mardi après-midi |  226 | Manuel Andia | [https://box.in2p3.fr/s/AcLJtPiWoe4fs6o](https://box.in2p3.fr/s/AcLJtPiWoe4fs6o) | 
| PM | jeudi après-midi | 226 |  Nathan Abitbol | [https://box.in2p3.fr/s/T3xB2SSfWBMiX4z](https://box.in2p3.fr/s/T3xB2SSfWBMiX4z) |
| LDD2 STAPS | vendredi après midi | 344| Jérémy Neveu | [https://box.in2p3.fr/s/Pwp6f9BFHqTosZG](https://box.in2p3.fr/s/Pwp6f9BFHqTosZG)|
| LDD2 MPSI TP-a | vendredi après midi | 213 | Corentin Morice | [https://box.in2p3.fr/s/Zd9Ec4kEoGf479k](https://box.in2p3.fr/s/Zd9Ec4kEoGf479k) |
| LDD2 MPSI TP-b | vendredi après midi |  215 | Nicolas Grenier | [https://box.in2p3.fr/s/rPCAoTT8WzGiZ5o](https://box.in2p3.fr/s/rPCAoTT8WzGiZ5o) |
|  LDD2 MPSI TP-c | vendredi après midi | 309 | Manuel Andia | [https://box.in2p3.fr/s/FGM9Z5f4SAnXZBY](https://box.in2p3.fr/s/FGM9Z5f4SAnXZBY) |

- **Avant de quitter la salle, veuillez vérifier avec votre enseignant que le document a été soumis correctement.**

### Barème indicatif <a class="anchor" id="B"></a>

Le sujet de l'examen comprend quatre exercices. Les trois premiers sont obligatoires pour tous les étudiants. Le quatrième exercice, portant sur les classes en Python, est réservé uniquement aux étudiants inscrits en double licence Mathématiques-Physique.

Le total des points attribuables pour l'examen est de 25/20. Ainsi, il n'est pas nécessaire de compléter l'intégralité des exercices pour obtenir le maximum de points.

La répartition approximative des 25 points pour tous les étudiants, à l'exception de ceux en double licence, est la suivante :

    Exercice 1 : 31 %
    Exercice 2 : 28 %
    Exercice 3 : 41 %

Pour les étudiants de la double licence Mathématiques-Physique, la répartition des points est :

    Exercice 1 : 24 %
    Exercice 2 : 21 %
    Exercice 3 : 32 %
    Exercice 4 : 23 %

+++

# Exercice 1: Remplacement d'une fonction coûteuse à calculer <a class="anchor" id="Ex1"></a>

Soit la fonction définie par $$f(x) = -\frac{log\left( 1-f(x)\right)}{x}$$

On souhaite calculer $f(x)$ pour 1000 valeurs de $x$ régulièrement espacées entre $x=2$ et $x=6$

* Ecrire une fonction $g(y,x)$ qui accepte deux arguments $y$ et $x$, et qui retourne la quantité $y + \frac{log\left( 1-y\right)}{x}$ .

```{code-cell} ipython3
---
nbgrader:
  grade: true
  grade_id: cell-ddcafaa9aa8bed5e
  locked: false
  points: 1
  schema_version: 3
  solution: true
  task: false
---
import numpy as np
import matplotlib.pyplot as plt

### BEGIN SOLUTION
def g(y,x):
    return y + (np.log(1-y))/x
### END SOLUTION
```

+++ {"nbgrader": {"grade": false, "grade_id": "cell-5bf93087ff1e05de", "locked": true, "schema_version": 3, "solution": false, "task": false}}

Remarquer que, pour une valeur de $x$ donnée, $g(y,x)$ s'annule pour la valeur de $y$ correspondant à $y=f(x)$. Calculer $f(x)$ pour une valeur de $x$ donnée revient donc à calculer la valeur de $y$ pour laquelle la fonction $g(y,x)$ s'annule.

* Pour chacune des trois valeurs de $x: x=2, x=4$ et $x=6$, représenter graphiquement $g(y,x)$ en fonction de $y$ entre 0.5 et 0.999999.

```{code-cell} ipython3
---
nbgrader:
  grade: true
  grade_id: cell-acae982ed9ea34cc
  locked: false
  points: 3
  schema_version: 3
  solution: true
  task: false
---
### BEGIN SOLUTION
ymin = 0.5
ymax = 0.999999

# représentation de la fonction pour x = 2, 4 et 6
y = np.linspace(ymin, ymax, 101)

fig = plt.figure()
plt.plot(y,g(y,2), label="x=2")
plt.plot(y,g(y,4), label="x=4")
plt.plot(y,g(y,6), label="x=6")
plt.ylim(-2., 2.)
plt.xlabel("y")
plt.ylabel("g(y,x)")
plt.axhline(0, linestyle='--')
plt.legend()
plt.show()
### END SOLUTION
```

+++ {"nbgrader": {"grade": false, "grade_id": "cell-c71419381c6a2e01", "locked": true, "schema_version": 3, "solution": false, "task": false}}

* Pour chacune de ces trois valeurs de $x$, combien la fonction a-t-elle de zéro(s) sur cet intervalle de $y$ ?

+++ {"nbgrader": {"grade": true, "grade_id": "cell-f2ecc068ab78c68f", "locked": false, "points": 1, "schema_version": 3, "solution": true, "task": false}}

### BEGIN SOLUTION
Pour chaque valeur de $x$, la fonction $g(y,x)$ s'annule pour une et une seule valeur de $y$
### END SOLUTION

+++ {"nbgrader": {"grade": false, "grade_id": "cell-588cda1b2c454a58", "locked": true, "schema_version": 3, "solution": false, "task": false}}

Pour une valeur donnée quelconque de $x$, on souhaite déterminer la valeur de ce zéro par la méthode de la dichotomie.

* Ecrire une fonction qui retourne la valeur de ce zéro. Cette fonction acceptera les quatre paramètres:
    - $x$ : valeur de la variable $x$
    - $y_{min}$ et $y_{max}$: intervalle de $y$ pour rechercher le zéro de $g(y,x)$
    - $\epsilon$ : précision souhaitée sur la valeur de ce zéro

Afficher la valeur du zéro dans les cas $x=2$, $x=4$ et $x=6$. On pourra choisir $\epsilon = 10^{-7}$.

```{code-cell} ipython3
---
nbgrader:
  grade: true
  grade_id: cell-c7772d1480285e45
  locked: false
  points: 4
  schema_version: 3
  solution: true
  task: false
---
### BEGIN SOLUTION
def dichotomie(x, a, b, epsilon):
    while (b - a) > epsilon :
        y = 0.5*( a + b )
        if (g(y,x)*g(a,x)) > 0.0 :
            a = y
        else:
            b = y
    return y

epsilon = 1E-7
print("x=2, y=", dichotomie(2, ymin, ymax, epsilon))
print("x=4, y=", dichotomie(4, ymin, ymax, epsilon))
print("x=6, y=", dichotomie(6, ymin, ymax, epsilon))
### END SOLUTION
```

+++ {"nbgrader": {"grade": false, "grade_id": "cell-2fa89ff0447593a7", "locked": true, "schema_version": 3, "solution": false, "task": false}}

* Utiliser cette méthode pour calculer 1000 valeurs de la fonction $f(x)$ entre 2 et 6, c'est-à-dire les valeurs $y$ qui annulent $g(y,x)$ pour des $x$ dans l'intervalle. Noter la valeur du temps nécessaire pour effectuer ce calcul comme indiqué ci-dessous.

```{code-cell} ipython3
---
nbgrader:
  grade: true
  grade_id: cell-8745884889b7ea37
  locked: false
  points: 3
  schema_version: 3
  solution: true
  task: false
---
# Calcul des 1000 valeurs par dichotomie
import time

tic = time.time()
### BEGIN SOLUTION
X = np.linspace(2., 6., 1000)
Y = []
for x in X:
    Y.append(dichotomie(x,ymin, ymax, epsilon))
### END SOLUTION
tac = time.time()
print("Durée du calcul", tac-tic)
```

+++ {"nbgrader": {"grade": false, "grade_id": "cell-08aa6c1fada77ac0", "locked": true, "schema_version": 3, "solution": false, "task": false}}

* Produire un graphique de la solution $y$ trouvée par dichotomie en fonction de $x$  entre 2 et 6.

```{code-cell} ipython3
---
nbgrader:
  grade: true
  grade_id: cell-db6bdf986c90938d
  locked: false
  points: 1
  schema_version: 3
  solution: true
  task: false
---
### BEGIN SOLUTION
fig = plt.figure()
plt.plot(X, np.array(Y))
plt.xlabel("x")
plt.ylabel("f(x)")
plt.show()
### END SOLUTION
```

+++ {"nbgrader": {"grade": false, "grade_id": "cell-d666a04cae891941", "locked": true, "schema_version": 3, "solution": false, "task": false}}

* On souhaite recalculer 1000 valeurs de f(x)f(x) en déterminant la solution $y$ telle que $g(y,x)=0$ par la méthode de dichotomie, mais en utilisant uniquement pour 50 valeurs de $x$ réparties entre 2 et 6. Les 950 autres valeurs seront obtenues par interpolation entre ces 50 points à l'aide de la méthode des splines.

Noter la valeur du temps nécessaire pour effectuer ce calcul.

On rappelle que la méthode des splines utilise les fonctions splrep et splev de la librairie scipy.interpolate:
- coefs = interp.splrep(XP, YP) fournit les paramètres de la courbe interpolante passant par les points (XP,YP)
- Y = interp.splev(X, coefs, der=0) fournit la valeur de la courbe interpolante correspondant à la valeur X

```{code-cell} ipython3
---
nbgrader:
  grade: true
  grade_id: cell-f25a5aa4fb3b631b
  locked: false
  points: 2
  schema_version: 3
  solution: true
  task: false
---
# Calcul utilisant l'interpolation splines
import scipy.interpolate as interp

tic = time.time()
### BEGIN SOLUTION
X = np.linspace(2., 6., 1000)
Xp = np.linspace(2., 6., 25)
Yp = []
for x in Xp:
    Yp.append(dichotomie(x,ymin, ymax, epsilon))
coefs = interp.splrep(Xp,Yp)
Ys = interp.splev(X, coefs, der=0) 
### END SOLUTION
tac = time.time()
print("Durée du calcul", tac-tic)
```

+++ {"nbgrader": {"grade": false, "grade_id": "cell-367e9356fb0f5a7c", "locked": true, "schema_version": 3, "solution": false, "task": false}}

* Sur un graphique, affichez l'écart entre les valeurs obtenues par interpolation et les valeurs obtenues directement par le calcul.

```{code-cell} ipython3
---
nbgrader:
  grade: true
  grade_id: cell-773748f6ba95fee6
  locked: false
  points: 2
  schema_version: 3
  solution: true
  task: false
---
### BEGIN SOLUTION
fig = plt.figure()
plt.plot(X, Ys, label='Interpolation')
plt.plot(X, np.array(Y), label='Calcul direct')
plt.xlabel('x')
plt.legend()
plt.show()
plt.plot(X, Ys-np.array(Y))
plt.xlabel('x')
plt.ylabel('ecart')
plt.show()
### END SOLUTION
```

* Qu'en concluez-vous ?

+++ {"nbgrader": {"grade": true, "grade_id": "cell-416217b937021387", "locked": false, "points": 1, "schema_version": 3, "solution": true, "task": false}}

### BEGIN SOLUTION
Avec l'interpolation, on retrouve les même résultats à mieux que $10^{-5}$ près (en fait, mieux que $10^{-6}$ près pour $x>2.5$), pour un calcul presque 30 fois plus rapide.
### END SOLUTION

+++ {"nbgrader": {"grade": false, "grade_id": "cell-3515df95df63c75a", "locked": true, "schema_version": 3, "solution": false, "task": false}, "editable": true, "slideshow": {"slide_type": ""}}

# Exercice 2: Stéganographie <a class="anchor" id="Ex2"></a>

La stéganographie est une technique qui vise à dissimuler la communication entre deux interlocuteurs. Le terme est composé des mots grecs στεγανός (couvert) et γραφία (écriture). En général, les messages cachés semblent être (ou font partie de) quelque chose d'autre : des images, des articles, des messages audio etc.

Dans cet exercice, vous devez trouver un message caché dans une image 

* Importer l’image couleur `./data/sand.png` avec la librarie matplotlib.image. Afficher l'image.

```{code-cell} ipython3
---
editable: true
nbgrader:
  grade: true
  grade_id: cell-927bbf823d297d2f
  locked: false
  points: 2
  schema_version: 3
  solution: true
  task: false
slideshow:
  slide_type: ''
---
### BEGIN SOLUTION
import matplotlib.image as mpimg
import numpy as np
import matplotlib.pyplot as plt

img = mpimg.imread("data/sand.png")

fig = plt.figure()
im = plt.imshow(img)
plt.show()
### END SOLUTION
```

+++ {"nbgrader": {"grade": false, "grade_id": "cell-66c51fbe92d5cabe", "locked": true, "schema_version": 3, "solution": false, "task": false}}

* Décomposer l'image en composantes RGB et tracer les histogrammes associés à chacune de ces composantes de couleur. Utiliser au moins 50 canaux pour chaque histogramme et représenter les ordonnées en échelle logarithmique avec l'option `log=True`

```{code-cell} ipython3
---
nbgrader:
  grade: true
  grade_id: cell-8e9cac045246fcaa
  locked: false
  points: 4
  schema_version: 3
  solution: true
  task: false
---
### BEGIN SOLUTION
Red=img[:,:,0]
Green=img[:,:,1]
Blue=img[:,:,2]
fig, axs = plt.subplots(1, 3, figsize=(12,4),sharey=True)
axs[0].hist(np.ravel(Red),color="red",bins=70,log=True)
axs[0].set_title('Composante Rouge')
axs[1].hist(np.ravel(Green),color="green",bins=70,log=True)
axs[1].set_title('Composante Verte')
axs[2].hist(np.ravel(Blue),color="blue",bins=70,log=True)
axs[2].set_title('Composante Bleue')
plt.show()
### END SOLUTION
```

+++ {"nbgrader": {"grade": false, "grade_id": "cell-5dbcd636d2c17287", "locked": true, "schema_version": 3, "solution": false, "task": false}}

Dans l'histogramme des composantes rouge et bleue, et un peu moins pour la composante verte, vous verrez une transition abrupte en ordonnées pour une certaine valeur d’abscisse appelée seuil dans la suite. Déterminer une valeur approximative pour ce seuil.

* Construire trois nouvelles images correspondant aux trois canaux RGB. Ces images sont nulles partout sauf pour les pixels dont la valeur est supérieure à la valeur seuil, pour lesquels elles sont égales à 1. 
*   Afficher ces nouvelles images.

```{code-cell} ipython3
---
nbgrader:
  grade: true
  grade_id: cell-80e51583027ddb94
  locked: false
  points: 5
  schema_version: 3
  solution: true
  task: false
---
### BEGIN SOLUTION
newimage=np.zeros(img.shape)
newimage[img>0.81]=1
fig, axs = plt.subplots(1, 3, figsize=(12,4),sharey=True)
axs[0].imshow(newimage[:,:,0])
axs[1].imshow(newimage[:,:,1])
axs[2].imshow(newimage[:,:,2])
plt.show()
### END SOLUTION
```

+++ {"nbgrader": {"grade": false, "grade_id": "cell-176422e10048a281", "locked": true, "schema_version": 3, "solution": false, "task": false}}

* Effectuer maintenant une convolution des trois images obtenues à la question précédente avec une moyenne glissante de fenêtre de taille 20 x 20. Afficher ces nouvelles images.

```{code-cell} ipython3
---
nbgrader:
  grade: true
  grade_id: cell-0ee9ffed40ea049e
  locked: false
  points: 5
  schema_version: 3
  solution: true
  task: false
---
### BEGIN SOLUTION
from scipy.signal import convolve2d
kernel=np.ones((20,20))

img_conv1 = convolve2d(newimage[:,:,0] , kernel )
img_conv2 = convolve2d(newimage[:,:,1] , kernel )
img_conv3 = convolve2d(newimage[:,:,2] , kernel )

fig, axs = plt.subplots(1, 3, figsize=(12,4),sharey=True)
axs[0].imshow(img_conv1)
axs[1].imshow(img_conv2)
axs[2].imshow(img_conv3)
plt.show()
### END SOLUTION
```

+++ {"nbgrader": {"grade": false, "grade_id": "cell-053183749b44ae43", "locked": true, "schema_version": 3, "solution": false, "task": false}}

* Quel était le message caché ? Jouer sur vos valeurs de seuils pour découvrir le message caché.

+++ {"nbgrader": {"grade": true, "grade_id": "cell-d4439407865900d9", "locked": false, "points": 1, "schema_version": 3, "solution": true, "task": false}}

### BEGIN SOLUTION
The answer is written in the sand
### END SOLUTION

+++ {"editable": true, "slideshow": {"slide_type": ""}}

# Exercice 3: Oscillateur harmonique amorti forcé <a class="anchor" id="Ex2"></a>

On considère un oscillateur harmonique amorti forcé de masse $m=1$. Le déplacement $x(t)$ de cet oscillateur par rapport à la position d'équilibre satisfait l'équation de Newton :
$$
\frac{d^2x}{dt^2} + \gamma \frac{dx}{dt} + \omega ^2 _0 x = a\sin(\omega t) 
$$
où $\gamma$ est le coefficient d'amortissement, $\omega _0$ la pulsation propre, $a$ l'amplitude d'une force externe sinusoïdale à laquelle l'oscillateur est soumis et $\omega$ la pulsation du forçage.

* Quel est l'ordre de cette équation différentielle ? S'agit-il d'une équation linéaire ou non-linéaire ? Argumenter.

+++ {"nbgrader": {"grade": true, "grade_id": "cell-6988ddf95afe676b", "locked": false, "points": 2, "schema_version": 3, "solution": true, "task": false}}

### BEGIN SOLUTION
Il s'agit d'une équation différentielle du second ordre non linéaire, qui ne contient que les dérivées de seconde et de première ordre de $x$, ainsi qu’un terme non linéaire $a\sin(\omega t)$.
### END SOLUTION

+++ {"nbgrader": {"grade": false, "grade_id": "cell-e188a5bd4a556fff", "locked": true, "schema_version": 3, "solution": false, "task": false}}

On peut réduire l'ordre de cette équation en la transformant en un système d'équations différentielles couplées d'ordre 1. Pour cela, on pose

$$ Y(t) = \left ( x(t), \frac{dx(t)}{dt} \right )$$

d'où on derive le système

$$ \frac{dY(t)}{dt} = F\left (Y(t), t \right )$$

avec 

$$F\left(Y(t), t \right)=\left ( \frac{dx(t)}{dt},  a\sin(\omega t) -\gamma \frac{dx(t)}{dt} - \omega ^2 _0 x \right )$$

* Importer, dans la cellule ci-dessous, la librairie `numpy`, le module `matplotlib.pyplot` et la fonction `odeint` du module `scipy.integrate`, dont vous allez avoir besoin par la suite.

```{code-cell} ipython3
---
nbgrader:
  grade: true
  grade_id: cell-b7dcfbde83ec142d
  locked: false
  points: 1
  schema_version: 3
  solution: true
  task: false
---
### BEGIN SOLUTION
import numpy as np
import matplotlib.pyplot as plt
from scipy.integrate import odeint
### END SOLUTION
```

+++ {"nbgrader": {"grade": true, "grade_id": "cell-41423f07d0fc4923", "locked": false, "points": 0, "schema_version": 3, "solution": true, "task": false}}

- Ecrire dans la cellule ci-dessous une fonction `func(y,t,omega0, gamma, a, omega)` qui définit $F(Y,t)$

```{code-cell} ipython3
---
nbgrader:
  grade: true
  grade_id: cell-f25fc9e7574115bf
  locked: false
  points: 2
  schema_version: 3
  solution: true
  task: false
---
### BEGIN SOLUTION
def func(y,t, omega0, gamma, a, omega):
    x=y[0]
    dxdt=y[1]
    return dxdt, a*np.sin(omega*t)-omega0**2*x-gamma*dxdt
### END SOLUTION
```

+++ {"nbgrader": {"grade": true, "grade_id": "cell-4a232d0ba9d4a3a9", "locked": false, "points": 0, "schema_version": 3, "solution": true, "task": false}}

On se propose de résoudre cette équation différentielle en utilisant la fonction `odeint()` de la librairie `scipy.integrate`. Dans le cas présent, où la fonction `func()` définie ci-dessus a des arguments autres que $y$ et $t$, vous pouvez faire appel à la fonction `odeint()` en utilisant un argument optionnel, `args`, qui regroupe les arguments supplémentaire de `func()`. La syntaxe dans ce cas est `odeint(func, y0, t, args=(omega0, gamma, a, omega))`.

On considère $a=1$, $\omega_0 = 1$, et $\gamma = 0$ (on néglige dans un premier temps l'amortissement). On cherche la solution sur l'intervalle de temps $[0, 50\,T_0]$ échantillonné avec 2000 points, où $T_0 =\frac{2\pi}{\omega_0}$ est la période propre de oscillateur. Les conditions initiales sont : $x_0=x(t=0)=1$ et $v_0 = \frac{dx}{dt}(t=0) = 0$.

* Trouver les solutions de l'équation différentielle pour les pulsations de forçage suivantes : $\omega = 0.5\omega_0$, $\omega = 0.9\omega_0$, $\omega = \omega_0$, $\omega = 1.1\omega_0$ et $\omega =1.5\omega_0$. Tracer, pour chacune de ces pulsations de forçage, l'évolution du déplacement $x(t)$, ainsi que la trajectoire dans l’espace des phases dans deux graphiques distincts.

```{code-cell} ipython3
---
nbgrader:
  grade: true
  grade_id: cell-62b1c4ae0002694e
  locked: false
  points: 5
  schema_version: 3
  solution: true
  task: false
---
### BEGIN SOLUTION
a=1
omega0=1.
gamma=0
T0=2*np.pi/omega0
x0=1
v0=0
Y0=[x0,v0]
temps=np.linspace(0,50*T0,2000)

omega_tab=omega0*np.array([0.5,0.9,1,1.1,1.5])

for omega in omega_tab:
    sol=odeint(func,Y0, temps, args=(omega0,gamma,a, omega))
    xs0, vs0=sol[:,0], sol[:,1]
   
    fig, ax=plt.subplots(1,2, figsize=(12,6))
    ax[0].plot(temps, xs0, label="position")
    #ax[0].plot(temps, vs, label="vitesse")
    ax[0].set_title(f'x(t) pour $\omega=$ {omega}, $\gamma=0$')
    ax[0].set_xlabel("$t$")
    ax[0].set_ylabel("$x(t)$")
    ax[0].legend()

    ax[1].plot(xs0, vs0, label="")
    ax[1].set_title(f'Portrait de phase pour $\omega=$ {omega}, $\gamma=0$')
    ax[1].set_xlabel(" $x$")
    ax[1].set_ylabel("$v$")
   
  
    plt.show()

### END SOLUTION
```

+++ {"nbgrader": {"grade": false, "grade_id": "cell-194646b8c80603b7", "locked": true, "schema_version": 3, "solution": false, "task": false}}

* Commenter les courbes tracées. Quelle est la particularité de l'amplitude du déplacement à la résonance ($\omega = \omega_0$) ? Qu'observe-t-on pour les pulsations de forçage proches de la résonance ?

+++ {"nbgrader": {"grade": true, "grade_id": "cell-ac85e4fbb9459cd0", "locked": false, "points": 3, "schema_version": 3, "solution": true, "task": false}}

### BEGIN SOLUTION

### END SOLUTION

+++ {"nbgrader": {"grade": false, "grade_id": "cell-7fb0632ec51e16e2", "locked": true, "schema_version": 3, "solution": false, "task": false}}

On considère le même oscillateur harmonique que précédemment, les mêmes conditions initiales, mais l'oscillateur subit un amortissement de coefficient $\gamma = 0.1\omega_0$.

*  Trouver les solutions de l'équation différentielle pour les pulsations de forçage suivantes :  $\omega = 0.5\omega_0$, $\omega = 0.9\omega_0$, $\omega = \omega_0$, $\omega = 1.1\omega_0$ et $\omega =1.5\omega_0$ sur l'intervalle de temps $[0,50\,T_0]$. Tracer, pour chacune de ces pulsations de forçage, l'évolution du déplacement $x(t)$ ainsi que le portrait de phase.

```{code-cell} ipython3
---
nbgrader:
  grade: true
  grade_id: cell-e6d3e0a0208a51e6
  locked: false
  points: 4
  schema_version: 3
  solution: true
  task: false
---
### BEGIN SOLUTION
gamma=0.1*omega0

for omega in omega_tab:
    sol=odeint(func,Y0, temps, args=(omega0,gamma,a, omega))
    xs, vs=sol[:,0], sol[:,1]
   
    fig, ax=plt.subplots(1,2, figsize=(12,6))
    ax[0].plot(temps, xs, label="position")
    #ax[0].plot(temps, vs, label="vitesse")
    ax[0].set_title(f'x(t) pour $\omega=$ {omega}, $\gamma=0.1$')
    ax[0].set_xlabel("$t$")
    ax[0].set_ylabel("$x(t)$")
    ax[0].legend()

    ax[1].plot(xs, vs, label="")
    ax[1].set_title(f'Portrait de phase pour $\omega=$ {omega}, $\gamma=0.1$')
    ax[1].set_xlabel(" $x$")
    ax[1].set_ylabel("$v$")
   
  
    plt.show()
### END SOLUTION
```

+++ {"nbgrader": {"grade": false, "grade_id": "cell-86f77000801384e4", "locked": true, "schema_version": 3, "solution": false, "task": false}}

* On observe sur les courbes du déplacement $x(t)$ un régime transitoire avant l'installation du régime permanent. Donner une estimation de la durée du régime transitoire. Comment peut-on distinguer le régime permanent du régime transitoire sur les trajectoires dans l'espace des phases ? Quelles sont les principales différences par rapport à l'oscillateur forcé non amorti étudié à la question 5 ?

+++ {"nbgrader": {"grade": true, "grade_id": "cell-6bd62289b40edc3c", "locked": false, "points": 2, "schema_version": 3, "solution": true, "task": false}}

### BEGIN SOLUTION

### END SOLUTION

+++ {"nbgrader": {"grade": false, "grade_id": "cell-dbd21514ceda0e45", "locked": true, "schema_version": 3, "solution": false, "task": false}}

* On veut caractériser la réponse de l'oscillateur autour de la résonance. La grandeur qui caractérise cette réponse est l'amplitude $x_{max}$ de l'oscillateur *en régime permanent*, c'est à dire après le régime transitoire. On peut obtenir $x_{max}$ pour une pulsation de forçage donnée en prenant la valeur absolue maximale du déplacement sur les dernières 500 valeurs de $x(t)$. Tracer les courbes de réponse de l'oscillateur ($x_{max}$ en fonction de $\omega$) pour les mêmes conditions initiales que précédemment et pour 4 valeurs de $\gamma$ : $0.05\omega_0$, $0.1\omega_0$, $0.2\omega_0$ et $0.5\omega_0$. Vous échantillonnerez $\omega$ avec un pas de 0.01 dans l'intervalle $[0.5 \omega_0, 1.5 \omega_0]$. Commenter le résultat.

```{code-cell} ipython3
---
nbgrader:
  grade: true
  grade_id: cell-3b5045d59b85b7bc
  locked: false
  points: 4
  schema_version: 3
  solution: true
  task: false
---
### BEGIN SOLUTION
omega_min=0.5*omega0
omega_max=1.5*omega0

omega_tab=np.arange(omega_min, omega_max, 0.01)

plt.figure()
plt.title(f'Courbe de réponse oscillateur harmonique forcé amorti')
plt.xlabel('$\omega$')
plt.ylabel('$x_{max}$')

for gamma in [0.05, 0.1, 0.2, 0.5]:
    xmax_tab=[]
    for omega in omega_tab:
    
        sol=odeint(func,Y0, temps, args=(omega0,gamma,a, omega))
        xs, vs=sol[:,0], sol[:,1]
        xmax=np.max(np.abs(xs[-500:]))
        xmax_tab.append(xmax)

    plt.plot(omega_tab, xmax_tab)
plt.show()
### END SOLUTION
```

+++ {"nbgrader": {"grade": false, "grade_id": "cell-e3e71fd2b7111b97", "locked": true, "schema_version": 3, "solution": false, "task": false}}

# Exercice 4 : jeu de cartes (LDD-MP) <a class="anchor" id="Ex3"></a>

### Cet exercise est à resoudre seulement par les étudiants de la double licence Math-Physique.

On souhaite modéliser un jeu de cartes et estimer numériquement la probabilité de piocher au moins une figure (valet ou "J", reine ou "Q", roi ou "K", as ou "A") dans une main initiale de 5 cartes, tirée au hasard et sans remplacement.

Les valeurs possibles pour les cartes qui ne sont pas des figures vont de 2 à 10.

```{code-cell} ipython3
import random
import numpy as np
import matplotlib.pyplot as plt

liste_figures = ["J", "Q", "K", "A"]
liste_valeurs = list(range(2, 11)) + liste_figures
N_valeurs = len(liste_valeurs)
print("Voici les {} valeurs possibles : {}".format(N_valeurs, liste_valeurs))
```

+++ {"editable": true, "slideshow": {"slide_type": ""}, "nbgrader": {"grade": false, "grade_id": "cell-e3eb4f0ca495b9cd", "locked": true, "schema_version": 3, "solution": false, "task": false}}

1. Écrivez une classe `Carte` qui modélise une carte, avec les propriétés suivantes :
   * Un attribut `valeur` défini à l'initialisation de l'instance (ou *instanciation*) ;
   * Une méthode `figure` qui renvoie `True` si `self.valeur` fait partie des valeurs possibles pour les figures (servez-vous de la variable globale `liste_figures` définie plus haut) ;
   * Une méthode `__repr__` qui renvoie la valeur de la carte **convertie en chaîne de caractères**.

```{code-cell} ipython3
---
editable: true
nbgrader:
  grade: true
  grade_id: cell-2a663860b259ecce
  locked: false
  points: 3
  schema_version: 3
  solution: true
  task: false
slideshow:
  slide_type: ''
---
### BEGIN SOLUTION
class Carte():
    def __init__(self, valeur):
        self.valeur = valeur
    def figure(self):
        return self.valeur in liste_figures
    def __repr__(self):
        return str(self.valeur)
### END SOLUTION
```

+++ {"editable": true, "slideshow": {"slide_type": ""}, "nbgrader": {"grade": false, "grade_id": "cell-98bcb5ab4ec1c973", "locked": true, "schema_version": 3, "solution": false, "task": false}}

2. Écrivez une classe `Main` qui modélise une main initiale avec un nombre $k$ de cartes piochées, avec les propriétés suivantes :
   * Un attribut `k`, défini à l'instanciation, qui représente le nombre de cartes piochées ;
   * Un attribut `cartes` (une liste), défini à l'instanciation, obtenu à partir du tirage aléatoire et sans remplacement de $k$ cartes (utiliser `random.sample` avec les bons arguments), chaque élément de cette liste doit être une instance de la classe `Carte` ;
   * Une méthode `contient_figure` qui renvoie `True` si une figure a été piochée parmi les cartes en main (vous pouvez par exemple utiliser `np.any` avec les bons arguments) ;
   * Une méthode `__repr__` qui renvoie une chaîne de caractères indiquant le nombre de cartes en main et la liste des cartes piochées avec leur valeur.

Lors de l'instanciation (méthode `__init__`) on s'assurera que le nombre de cartes tirées $k$ est inférieur ou égal au nombre de cartes qu'il est possible de tirer (`N_valeurs` défini plus haut).

```{code-cell} ipython3
---
editable: true
nbgrader:
  grade: true
  grade_id: cell-7881adb86668ee57
  locked: false
  points: 4
  schema_version: 3
  solution: true
  task: false
slideshow:
  slide_type: ''
---
### BEGIN SOLUTION
class Main():
    def __init__(self, k=5):
        assert k <= N_valeurs
        self.k = k
        choix = random.sample(liste_valeurs, k=k)
        self.cartes = [Carte(carte) for carte in choix]
    def contient_figure(self):
        return np.any([carte.figure() for carte in self.cartes])
    def __repr__(self):
        return "Main de {} cartes: {}".format(self.k, self.cartes)
### END SOLUTION
```

+++ {"nbgrader": {"grade": false, "grade_id": "cell-f7068ad920f5e0c2", "locked": true, "schema_version": 3, "solution": false, "task": false}}

3. Testez votre classe `Main` en tirant $k=5$ cartes aléatoires :
   * Affichez l'objet ainsi créé (avec `print`) et vérifiez que ce qui s'affiche correspond bien à ce que vous avez précédemment programmé dans les méthodes `__repr__` ;
   * Affichez également le résultat de la méthode `contient_figure` et vérifiez que la réponse donnée a un sens (vous pouvez ré-exécuter la cellule plusieurs fois jusqu'à tomber sur une main sans figures et vérifier que la méthode renvoie bien `False`).

```{code-cell} ipython3
---
editable: true
nbgrader:
  grade: true
  grade_id: cell-7d25cf17656545cd
  locked: false
  points: 2
  schema_version: 3
  solution: true
  task: false
slideshow:
  slide_type: ''
---
### BEGIN SOLUTION
m = Main(5)
print(m, m.contient_figure())
### END SOLUTION
```

+++ {"nbgrader": {"grade": false, "grade_id": "cell-9a4b09c4aa6a7ca1", "locked": true, "schema_version": 3, "solution": false, "task": false}}

4. Effectuez $M=10 000$ tirages de $k=5$ cartes chacun en utilisant votre classe `Main`. Quelle est la probabilité de piocher au moins 1 figure pour une main initiale de 5 cartes ?

```{code-cell} ipython3
---
nbgrader:
  grade: true
  grade_id: cell-420e74ef821a9451
  locked: false
  points: 3
  schema_version: 3
  solution: true
  task: false
---
### BEGIN SOLUTION
res = 0
k = 5
M = 10000
for i in range(M):
    m = Main(k)
    res += int(m.contient_figure())
print("Probabilité de piocher au moins 1 figure sur {} cartes dans la main initiale : {:.4f}".format(k, res/M))
### END SOLUTION
```

+++ {"nbgrader": {"grade": false, "grade_id": "cell-058e8972f5df42f7", "locked": true, "schema_version": 3, "solution": false, "task": false}}

5. Faites une boucle sur la valeur de $M$ (en prenant les valeurs 1, 2, 5, 10, 100, 1 000, 2 000, 5 000 et 10 000) et tracez, en échelle semi-logarithmique (`plt.semilogx`), la probabilité de piocher au moins 1 figure pour une main initiale de $k=5$ cartes en fonction du nombre de tirages, $M$. **Veillez à soigner le graphe (titres des axes, grille, etc.).**

```{code-cell} ipython3
---
editable: true
nbgrader:
  grade: true
  grade_id: cell-6c96d0906d43db06
  locked: false
  points: 3
  schema_version: 3
  solution: true
  task: false
slideshow:
  slide_type: ''
---
### BEGIN SOLUTION
p_num = []
M = np.array([1, 2, 5, 10, 100, 1000, 2000, 5000, 10000])
for i in M:
    res = 0
    for j in range(i):
        m = Main(5)
        res += int(m.contient_figure())
    p_num.append(res/i)

p_num = np.array(p_num)

plt.semilogx(M, p_num)
plt.xlabel("$M$")
plt.ylabel(r"$p_\mathrm{num}$")
plt.grid(True)
### END SOLUTION
```

+++ {"nbgrader": {"grade": false, "grade_id": "cell-c9bbb97cebfdc458", "locked": true, "schema_version": 3, "solution": false, "task": false}}

6. **Défi (bonus) :**

On souhaite comparer nos résultats avec la prédiction théorique (distribution hypergéométrique) pour piocher au moins 1 figure en tirant $k=5$ cartes parmi $N=13$, sachant qu'il y a $F=4$ figures :

$$
p_\mathrm{th} = P(s\geq 1;k,F,N) = \displaystyle\sum_{s=1}^F \dfrac{\binom{F}{s} \binom{N-F}{k-s}}{\binom{N}{k}}
$$

où $\binom{j}{i}$ représente la loi binomiale (nombre de combinaisons de $i$ éléments parmi $j$ sans remplacement).

 * Représentez, en échelle logarithmique (`plt.loglog`), la valeur absolue de l'erreur relative $\epsilon$ entre le résultat numérique $p_\mathrm{num}$ et le résultat théorique $p_\mathrm{th}$ en fonction du nombre de lancers $M$ pour les valeurs de la question 5 :

$$
\epsilon = \left|\dfrac{p_\mathrm{num} - p_\mathrm{th}}{p_\mathrm{th}}\right|
$$

Vous pouvez outiliser la fonction `binom()` du module `scipy.special`.

```{code-cell} ipython3
---
editable: true
nbgrader:
  grade: true
  grade_id: cell-29d3d82bb20cda5c
  locked: false
  points: 3
  schema_version: 3
  solution: true
  task: false
slideshow:
  slide_type: ''
---
### BEGIN SOLUTION
from scipy.special import binom
F = 4
N = 13
k = 5
p_th = np.sum([binom(F, s) * binom(N-F, k-s) / binom(N, k) for s in range(1, F+1)])
epsilon = np.abs((p_num - p_th) / p_th)

plt.loglog(M, epsilon)
plt.xlabel("M")
plt.ylabel(r"$\epsilon$")
plt.grid(True)
### END SOLUTION
```
